/*

BOOTP example for DSock, copyright (C) 2002 by DM&P.
This example will show you how to use BOOTP/DHCP function of DSock.

*/

#include "..\dsock.h"
#include <stdio.h>

int main()
{
  char  szBuf[32];
  BYTE  *pbyMac;
  DWORD dwIp;

  printf("\nDM&P DSock BOOTP/DHCP Example\n\n");

  /* Initialize DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Use BOOTP/DHCP to get setup */
  if(DSock_DoBootp() == TRUE)
  {
    printf("Load network setup from BOOTP/DHCP\n");
  }
  else  /* Load setup from config file */
  {
    printf("Unable to load setup from BOOTP/DHCP server\n");
    DSock_LoadConfigFile("dsock.cfg");
    printf("Load network setup from DSOCK.CFG\n");
  }

  /* Dump network info */
  pbyMac = DSock_GetMacAddr();
  printf("MAC     : %02X-%02X-%02X-%02X-%02X-%02X\n", pbyMac[0], pbyMac[1],
           pbyMac[2], pbyMac[3], pbyMac[4], pbyMac[5]);

  dwIp = DSock_GetHostIp();
  inet_ntoa(szBuf, dwIp);
  printf("IP      : %s\n", szBuf);

  dwIp = DSock_GetNetmask();
  inet_ntoa(szBuf, dwIp);
  printf("Netmask : %s\n", szBuf);

  dwIp = DSock_GetGateway();
  inet_ntoa(szBuf, dwIp);
  printf("Gateway : %s\n", szBuf);

  dwIp = DSock_GetDomainNameServer();
  inet_ntoa(szBuf, dwIp);
  printf("DNS     : %s\n", szBuf);

  /* Close DSock library */
  DSock_Close();

  return 0;
}
