/*

DNS example for DSock, copyright (C) 2002 by DM&P.
This example show you how to get IP address from domain name.

*/

#include "..\dsock.h"
#include <stdio.h>

int main(int nArgCnt, char *pszArg[])
{
  char  szBuf[32];
  BYTE  *pbyMac;
  DWORD dwIp;

  printf("\nDM&P DSock DNS Example\n\n");

  /* Check arguments */
  if(nArgCnt != 2)
  {
    printf("Usage: DNS <domain name>\n");
    printf("   Ex: DNS www.dmp.com.tw\n");
    return 1;
  }

  /* Open DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Load network setup from config file */
  DSock_LoadConfigFile("dsock.cfg");

  /* Dump network info */
  pbyMac = DSock_GetMacAddr();
  printf("MAC     : %02X-%02X-%02X-%02X-%02X-%02X\n", pbyMac[0], pbyMac[1],
          pbyMac[2], pbyMac[3], pbyMac[4], pbyMac[5]);

  dwIp = DSock_GetHostIp();
  inet_ntoa(szBuf, dwIp);
  printf("IP      : %s\n", szBuf);

  dwIp = DSock_GetNetmask();
  inet_ntoa(szBuf, dwIp);
  printf("Netmask : %s\n", szBuf);

  dwIp = DSock_GetGateway();
  inet_ntoa(szBuf, dwIp);
  printf("Gateway : %s\n", szBuf);

  dwIp = DSock_GetDomainNameServer();
  inet_ntoa(szBuf, dwIp);
  printf("DNS     : %s\n", szBuf);

  /* Use DSock_Resolve() to get IP address from domain name */
  printf("\n");
  dwIp = DSock_Resolve(pszArg[1]);
  printf("%s = %s\n", pszArg[1], inet_ntoa(szBuf, dwIp));

  /* Close DSock library */
  DSock_Close();

  return 0;
}
