/*

Web server example for DSock, copyright (C) 2002 by DM&P.
It's a simple web server for demo only. You can improve it to support
multi-user and more HTTP extension.

*/

#include "..\dsock.h"
#include <stdio.h>
#include <string.h>
#include <conio.h>

#define HTTP_PORT 80

void  Convert(char *p2);  /* Convert encode query string. */
BOOL  HttpServer(SOCKET s);

int main()
{
  DWORD   dwIp;
  char    szBuf[32];
  SOCKET  s;
  char    *sz = "-\\|/";
  uint    nCnt = 0;

  printf("\nDM&P DSock Web Server Example\n\n");

  /* Open DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Load network setup from config file */
  DSock_LoadConfigFile("dsock.cfg");

  /* Show server IP */
  dwIp = DSock_GetHostIp();
  inet_ntoa(szBuf, dwIp);
  printf("HTTP Server IP : %s\n", szBuf);

  /* Create socket for HTTP server */
  s = SocketCreate(TCP_SOCKET);
  if(s == INVALID_SOCKET)
  {
    printf("SocketCreate() error\n");
    DSock_Close();
    return 1;
  }

  if(SocketBind(s, 0L, HTTP_PORT) == FALSE)
  {
    printf("SocketBind() error\n");
    SocketDestory(s);
    DSock_Close();
    return 1;
  }

  if(SocketListen(s) == FALSE)
  {
    printf("SocketListen() error\n");
    SocketDestory(s);
    DSock_Close();
    return 1;
  }

  /*
  We change HttpServer() to non-blocking function for programmer to check HTTP
  connection. You can add HTTP or TELNET server checking routine into checking
  loop to support multiple services.
  */
  while(TRUE)
  {
    printf("%c\r", sz[nCnt++ / 500 % 4]);
    if(kbhit())           /* Press any key to break */
      break;
    HttpServer(s);
  }

  /* Destory HTTP server socket */
  SocketDestory(s);

  /* Close DSock library */
  DSock_Close();

  return 0;
}

BOOL HttpServer(SOCKET s)
{
  char  szBuf[1024];
  char  szBuf2[1024];
  char  *p, *p2;
  DWORD dwIp;
  BOOL  bPost;

  if(SocketAccept(s, &dwIp) == FALSE)
    return TRUE;

  inet_ntoa(szBuf, dwIp);
  printf("HTTP: Accepting request from %s: ", szBuf);
  SocketGetString(s, szBuf, 1024);
  printf("%s\n", szBuf);

  /* Request string: <GET|POST> </PATH> <HTTP/VERSION> */

  /* Get path */
  p = szBuf;
  while(*p != '/')
    p++;
  p2 = p;
  while(*p2 != ' ')
    p2++;
  *p2 = 0;  /* Now, p point to ASCIIZ of path */

  bPost = strnicmp(szBuf, "POST", 4) == 0;
  if(bPost)
  {
    /* Query string of POST method will start with a null line. */
    while(SocketDataReady(s))
    {
      SocketGetString(s, szBuf2, 1024);
      if(stricmp(szBuf2, "") == 0)
        break;
    }

    SocketGetString(s, szBuf2, 1024);
    p2 = szBuf2;
  }
  else
  {
    p2 = p;
    while((*p2 != '?') && (*p2 != 0))
      p2++;
    *p2 = 0;
    p2++;
  }

  /* Now, p2 point to query string */
  if(stricmp(p, "/") == 0)      /* Send default page */
    p = "/default.htm";

  if(stricmp(p, "/demo") == 0)  /* Show demo string */
  {
    /* Prase your query string here */

    /* You can get more example on Mity-Mite Demo Box source code. */
    SocketPutString(s,
                        "<html><head><title>DSock Web Server Example</title></head><body>\n");
    SocketPutString(s, "<h1>DSock Web Server Example</h2>\n");
    sprintf(szBuf, "Query string is <b>%s</b>\n", p2);
    SocketPutString(s, szBuf);
    SocketPutString(s, "<p><a href=\"/\">Back</a>\n");
    SocketPutString(s, "</body></html>\n");
  }
  else  /* Send file only */
  {
    FILE  *fp = fopen(p + 1, "rb");
    if(fp == NULL)
    {
      SocketPutString(s, "<html><head><title>Error</title></head><body>\n");
      SocketPutString(s, "<h2>Unable to open '%s'</h2>\n", p + 1);
      SocketPutString(s, "<p><hr><a href=\"/\">Back</a>\n");
      SocketPutString(s, "</body></html>\n");
    }
    else
    {
      int nLen;
      while(!feof(fp))
      {
        nLen = fread(szBuf, 1, 1024, fp);
        SocketSend(s, (uchar *)szBuf, nLen);
      }

      fclose(fp);
    }
  }

  SocketClose(s);
  SocketBind(s, 0L, HTTP_PORT);
  SocketListen(s);
  return TRUE;
}

void Convert(char *p2)
{
  char  *p = p2;
  while(*p)
  {
    if(*p == '+')
      *p2 = ' ';
    else if(*p == '%')
    {
      char  c;
      p++;
      c = *p >= 'A' ? *p - 'A' + 10 : *p - '0';
      p++;
      c *= 16;
      c += (*p >= 'A' ? *p - 'A' + 10 : *p - '0');
      *p2 = c;
    }
    else
      *p2 = *p;
    p++;
    p2++;
  }

  *p2 = 0;
}
