/*

SMTP server example for DSock, copyright (C) 2002 by DM&P.
This example is a tiny SMTP server that can receive mail for client.
It just receive mail and display mail on screen.

*/

#include "..\dsock.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <stdlib.h>

#define SMTP_PORT 25

BOOL  SmtpServer(SOCKET s); /* SMTP server */

int main()
{
  DWORD   dwIp;
  char    szBuf[1024];
  SOCKET  s;
  char    *sz = "-\\|/";
  uint    nCnt = 0;

  printf("\nDM&P DSock SMTP Server Example\n\n");

  /* Open DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Load network setup from config file */
  DSock_LoadConfigFile("dsock.cfg");

  /* Show server IP */
  dwIp = DSock_GetHostIp();
  inet_ntoa(szBuf, dwIp);
  printf("SMTP Server IP : %s\n", szBuf);

  /* Create DMTP server socket */
  s = SocketCreate(TCP_SOCKET);
  if(s == INVALID_SOCKET)
  {
    printf("SocketCreate() error\n");
    DSock_Close();
    return 1;
  }

  if(SocketBind(s, 0L, SMTP_PORT) == FALSE)
  {
    printf("SocketBind() error\n");
    SocketDestory(s);
    DSock_Close();
    return 1;
  }

  if(SocketListen(s) == FALSE)
  {
    printf("SocketListen() error\n");
    SocketDestory(s);
    DSock_Close();
    return 1;
  }

  /*
  We change SmtpServer() to non-blocking function for programmer to check SMTP
  connection. You can add HTTP or TELNET server checking routine into checking
  loop to support multiple services.
  */
  while(TRUE)
  {
    printf("%c\r", sz[nCnt++ / 500 % 4]);
    if(kbhit()) /* Press any key to break */
      break;
    SmtpServer(s);
  }

  /* Close SMTP socket */
  SocketDestory(s);

  /* Close DSock library */
  DSock_Close();

  return 0;
}

BOOL SmtpServer(SOCKET s)
{
  char  szBuf[1024];
  DWORD dwIp;

  if(SocketAccept(s, &dwIp) == FALSE)
    return FALSE;

  inet_ntoa(szBuf, dwIp);
  printf("SMTP: Accepting mail from %s\n", szBuf);

  SocketPutString(s, "220 dsock.dmp.com.tw DSockMail ready\r\n");

  while(TRUE)
  {
    if(kbhit())
      break;
    if(SocketDataReady(s) == FALSE)
      continue;
    SocketGetString(s, szBuf, 1024);
    printf("SMTP: %s\n", szBuf);
    if(strnicmp(szBuf, "HELO", 4) == 0)
    {
      SocketPutString(s, "250 Mity-Mite Module\r\n");
    }
    else if(strnicmp(szBuf, "MAIL", 4) == 0)
    {
      SocketPutString(s, "250 OK\r\n");
    }
    else if(strnicmp(szBuf, "RCPT", 4) == 0)
    {
      SocketPutString(s, "250 OK\r\n");
    }
    else if(strnicmp(szBuf, "QUIT", 4) == 0)
    {
      SocketPutString(s, "221 Bye\r\n");
      break;
    }
    else if(strnicmp(szBuf, "DATA", 4) == 0)
    {
      SocketPutString(s,
                            "354 Enter mail, end with \".\" on a line by itself\r\n");

      /* Display mail on screen only */
      while(TRUE)
      {
        if(kbhit())
          break;
        if(SocketDataReady(s) == FALSE)
          continue;
        SocketGetString(s, szBuf, 1024);
        printf("      %s\n", szBuf);
        if(stricmp(szBuf, ".") == 0)
          break;
      }

      SocketPutString(s, "250 Okay\r\n");
    }
    else if(strnicmp(szBuf, "NOOP", 4) == 0)
    {
      SocketPutString(s, "250 NOOP\r\n");
    }
    else        /* Other commands are not support */
    {
      SocketPutString(s, "500 Error\r\n");
    }
  }

  /* Enter listening modem again */
  SocketClose(s);
  SocketBind(s, 0L, SMTP_PORT);
  SocketListen(s);
  return FALSE;
}
