/*

Talk (TCP) example for DSock, copyright (C) 2002 by DM&P.
It's talk server for TALK_TCP example. It will show you how to write a
server to accept multiple clients.

*/

#include "..\dsock.h"
#include <stdio.h>
#include <conio.h>

#define TALK_PORT   1234
#define MAX_SOCKETS 5

/* Check connection and read data from clients */
BOOL    Polling(SOCKET s, BOOL *bConnected);

char    _szBuf[32];
DWORD   _dwIp;
SOCKET  _Socket[MAX_SOCKETS];
BOOL    _bConnected[MAX_SOCKETS];

/*
You can declare only one socket for listening. Create another socket when
listening socket is connected with client until out of memory. We use fixed
socket number for example and it is not good for memory usage.
*/
int main()
{
  int i;

  printf("\nDM&P DSock Talk-TCP Server Example\n\n");

  /* Open DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Load network setup from config file */
  DSock_LoadConfigFile("dsock.cfg");

  /* Show my IP */
  _dwIp = DSock_GetHostIp();
  inet_ntoa(_szBuf, _dwIp);
  printf("Talk Server IP: %s\n", _szBuf);

  for(i = 0; i < MAX_SOCKETS; i++)
  {
    /* We remove checking here to reduce code */
    _Socket[i] = SocketCreate(TCP_SOCKET);
    SocketBind(_Socket[i], 0L, TALK_PORT);
    SocketListen(_Socket[i]);
    _bConnected[i] = FALSE;
  }

  printf("Talk server is running...\n");

  while(TRUE)
  {
    /* Polling all connections */
    for(i = 0; i < MAX_SOCKETS; i++)
    {
      if(Polling(_Socket[i], &_bConnected[i]) == FALSE)
      {
        /* We re-create the socket connected with the client has disconneted */
        SocketClose(_Socket[i]);
        SocketDestory(_Socket[i]);
        _Socket[i] = SocketCreate(TCP_SOCKET);
        SocketBind(_Socket[i], 0L, TALK_PORT);
        SocketListen(_Socket[i]);
      }
    }

    /* Send key press to all clients */
    if(kbhit())
    {
      char  c = getch();
      for(i = 0; i < MAX_SOCKETS; i++)
      {
        if(_bConnected[i])
          SocketPutChar(_Socket[i], c);
      }

      if(c == 27) /* Server shut down, close all connection */
      {
        for(i = 0; i < MAX_SOCKETS; i++)
        {
          if(_bConnected[i])
            SocketClose(_Socket[i]);
          SocketDestory(_Socket[i]);
        }

        printf("\nServer terminated\n");
        break;
      }
    }
  }

  /* Close DSock library */
  DSock_Close();

  return 0;
}

/* Check connection and read data from clients */
BOOL Polling(SOCKET s, BOOL *bConnected)
{
  if(*bConnected == FALSE)
  {
    if(SocketAccept(s, &_dwIp))
    {
      *bConnected = TRUE;
      inet_ntoa(_szBuf, _dwIp);
      printf("\nConnected with %s\n", _szBuf);
    }
  }
  else  /* Connected */
  {
    /* Is client disconneted ? */
    if(SocketIsConnected(s) == FALSE)
    {
      printf("\nClient terminated\n");
      *bConnected = FALSE;
      return FALSE;
    }

    /* Any data come in ? */
    if(SocketDataReady(s))
    {
      char  c;
      SocketGetChar(s, &c);
      printf("%c", c);
    }
  }

  return TRUE;
}
