/*

Talk (TCP) example for DSock, copyright (C) 2002 by DM&P.
It's show you how to use sockets to connect to Internet. It's also provide
a Windows version written by WinSock.

*/

#include "..\dsock.h"
#include <stdio.h>
#include <conio.h>

#define TALK_PORT 1234

char  szBuf[32];

BOOL  TalkServer(SOCKET s);
BOOL  TalkClient(SOCKET s, char *szServer);

int main(int nArgCnt, char **pszArg)
{
  DWORD   dwIp;
  SOCKET  s;

  printf("\nDM&P DSock Talk-TCP Example Program\n\n");

  /* Open DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Load network setup from config file */
  DSock_LoadConfigFile("dsock.cfg");

  /* Show my IP */
  dwIp = DSock_GetHostIp();
  inet_ntoa(szBuf, dwIp);
  printf("My IP : %s\n", szBuf);

  s = SocketCreate(TCP_SOCKET);
  if(s == INVALID_SOCKET)
  {
    printf("SocketCreate() error\n");
    DSock_Close();
    return 1;
  }

  if(nArgCnt == 1)  /* Server mode */
    TalkServer(s);
  else  /* Client mode */
    TalkClient(s, pszArg[1]);

  SocketClose(s);
  SocketDestory(s);

  /* Close DSock library */
  DSock_Close();

  return 0;
}

BOOL TalkServer(SOCKET s)
{
  DWORD dwIp;
  BOOL  bConnected = FALSE;

  if(SocketBind(s, 0L, TALK_PORT) == FALSE)
  {
    printf("SocketBind() error\n");
    return FALSE;
  }

  if(SocketListen(s) == FALSE)
  {
    printf("SocketListen() error\n");
    return FALSE;
  }

  printf("Talk server mode, listening...\n");

  /* Wait for client */
  while(TRUE)
  {
    if(kbhit())
    {
      printf("Break by user\n");
      break;
    }

    if(SocketAccept(s, &dwIp))
    {
      bConnected = TRUE;
      inet_ntoa(szBuf, dwIp);
      printf("Connected with %s\n", szBuf);
      break;
    }
  }

  /* Is connected with client ? */
  if(bConnected)
  {
    printf("Start to talk...\n");
    while(TRUE)
    {
      /* Check key press */
      if(kbhit())
      {
        char  c = getch();
        SocketPutChar(s, c);
        if(c == 27)
        {
          printf("\nProgram terminated\n");
          break;
        }
      }

      /* Check message sent by client */
      if(SocketDataReady(s))
      {
        char  c;
        SocketGetChar(s, &c);
        printf("%c", c);
        if(c == 27)
        {
          printf("\nProgram terminated\n");
          break;
        }
      }
    }

    SocketClose(s);
  }

  return TRUE;
}

BOOL TalkClient(SOCKET s, char *szServer)
{
  printf("Talk client mode, connecting to server...\n");

  /* Connect to server */
  if(SocketConnect(s, inet_addr(szServer), TALK_PORT) == FALSE)
  {
    printf("SocketConnect() error\n");
    return FALSE;
  }

  printf("Connected to %s:%d\n", szServer, TALK_PORT);
  while(TRUE)
  {
    /* Check key press and send it out */
    if(kbhit())
    {
      char  c = getch();
      SocketPutChar(s, c);
      if(c == 27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }

    /* Check key press sent by server */
    if(SocketDataReady(s))
    {
      char  c;
      SocketGetChar(s, &c);
      printf("%c", c);
      if(c == 27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }
  }

  return TRUE;
}
