
#include <stdio.h>
#include <conio.h>
#include <winsock.h>

#define TALK_PORT 1234

BOOL TalkServer();
BOOL TalkClient(char *szServer);

int main(int nArgCnt,char **pszArg)
{
  /* Initialize WinSock.DLL */
  WSADATA WSAData;
  if(WSAStartup(0x101,(LPWSADATA)&WSAData)!=0)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  printf("\nDM&P Talk-TCP Example\n\n");

  if(nArgCnt==1)
    TalkServer();
  else
    TalkClient(pszArg[1]);

  /* Uninitialize WinSock.DLL */
  WSACleanup();
  return 0;
}

BOOL TalkServer()
{
  SOCKET s = socket(AF_INET,SOCK_STREAM,0);
  sockaddr_in sai;
  sai.sin_family = AF_INET;
  sai.sin_addr.s_addr = inet_addr("0.0.0.0");
  sai.sin_port = htons(TALK_PORT);

  bind(s,(LPSOCKADDR)&sai,sizeof(sai));
  listen(s,1);
  printf("Talk server mode, listening...\n");

  BOOL bConnected = FALSE;
  SOCKET s2;
  int nLen = sizeof(sai);
  while(TRUE)
  {
    if(kbhit())
    {
      printf("Break by user\n");
      break;
    }
    s2 = accept(s,(LPSOCKADDR)&sai,&nLen);
    if(s2!=INVALID_SOCKET)
    {
      bConnected = TRUE;
      printf("Connected with %s:%d\n",inet_ntoa(sai.sin_addr),1234);
      break;
    }
  }

  if(bConnected==FALSE)
  {
    closesocket(s);
    return FALSE;
  }

  printf("Start to talk...\n");
  char c;
  while(TRUE)
  {
    /* Check key press */
    if(kbhit())
    {
      c = getch();
      send(s2,&c,sizeof(char),0);
      if(c==27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }
    /* Check message from client */
    DWORD lArg = 1;
    ioctlsocket(s2,FIONBIO,&lArg);
    int nRet = recv(s2,&c,sizeof(char),MSG_PEEK);
    lArg=0;
    ioctlsocket(s2,FIONBIO,&lArg);
    if(nRet!=SOCKET_ERROR)
    {
      recv(s2,&c,sizeof(char),0);
      printf("%c",c);
      if(c==27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }
  }
  closesocket(s2);
  closesocket(s);
  return TRUE;
}

BOOL TalkClient(char *szServer)
{
  SOCKET s = socket(AF_INET,SOCK_STREAM,0);
  sockaddr_in sai;
  printf("Talk client mode, connecting to %s\n",szServer);
  sai.sin_family = AF_INET;
  sai.sin_addr.s_addr = inet_addr(szServer);
  sai.sin_port = htons(TALK_PORT);

  if(connect(s,(LPSOCKADDR)&sai,sizeof(sai))==SOCKET_ERROR)
  {
    printf("(%d) Unable to connect to server\n",WSAGetLastError());
    return FALSE;
  }

  printf("Connected to %s:%d\n",szServer,TALK_PORT);
  char c;
  while(TRUE)
  {
    /* Check key press */
    if(kbhit())
    {
      c = getch();
      send(s,&c,sizeof(char),0);
      if(c==27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }
    /* Check message from server */
    DWORD lArg = 1;
    ioctlsocket(s,FIONBIO,&lArg);
    int nRet = recv(s,&c,sizeof(char),MSG_PEEK);
    lArg = 0;
    ioctlsocket(s,FIONBIO,&lArg);
    if(nRet!=SOCKET_ERROR)
    {
      recv(s,&c,sizeof(char),0);
      printf("%c",c);
      if(c==27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }
  }
  closesocket(s);
  return TRUE;
}
