/*

Talk (UDP) example for DSock, copyright (C) 2002 by DM&P.
This example will show you use broadcasr with UDP. It's also provide a Windows
version written by WinSock.

*/

#include "..\dsock.h"
#include <stdio.h>
#include <conio.h>

int main()
{
  SOCKET  s;

  printf("\nDM&P DOS Sockets Talk-UDP Example Program\n\n");

  /* Open DSock library */
  if(DSock_Open() == FALSE)
  {
    printf("Unable to initialize socket library\n");
    return 1;
  }

  /* Load network setup from config file */
  DSock_LoadConfigFile("dsock.cfg");

  s = SocketCreate(UDP_SOCKET);
  if(s == INVALID_SOCKET)
  {
    printf("SocketCreate() error\n");
    DSock_Close();
    return 1;
  }

  if(SocketBind(s, 0xFFFFFFFFL, 1234) == FALSE)
  {
    printf("SocketBind() error\n");
    DSock_Close();
    return 1;
  }

  printf("Start to talk, any press will be broadcast...\n");
  while(TRUE)
  {
    /* User press keyboard ? */
    if(kbhit())
    {
      char  c = getch();
      SocketPutChar(s, c);
      if(c == 27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }

    /* Is there any broadcast message ? */
    if(SocketDataReady(s))
    {
      char  c;
      SocketGetChar(s, &c);
      /*SocketSendTo(inet_addr("192.168.0.19"),1234,&c,1);*/
      printf("%c", c);
      if(c == 27)
      {
        printf("\nProgram terminated\n");
        break;
      }
    }
  }

  SocketClose(s);
  SocketDestory(s);

  /* Close DSock library */
  DSock_Close();

  return 0;
}
